<?php
function checkRendering($topic, $web, $expected) {
	global $_SITE;

	/* this is only one implementation.  You may wish to return
	   'true' in all cases and re-render every page in a web
	   whenever the web header changes. */

	if ( ! $result = FetchWikiEntry($topic, $web, $expected) ) { return; }
	$trow = mysql_fetch_array($result);
	$topic_date = $trow["lastedit"];

	if( $result = FetchWikiEntry("[format-$web-header]", $web, $expected) ) {
		$row = mysql_fetch_array($result);
		$header_date = $row["lastedit"];

		if( $header_date > $topic_date ) {
			include( $_SITE["mirrordir"] . "edit.inc" );
			saveWikiTopic( $topic, $web, $trow["full_text"], $trow["summary"] );
			return true;
			}
		}

	if( $result = FetchWikiEntry("[format-$web-footer]", $web, $expected) ) {
		$row = mysql_fetch_array($result);
		$footer_date = $row["lastedit"];	

		if ( $footer_date > $topic_date ) {
			include( $_SITE["mirrordir"] . "edit.inc" );
			saveWikiTopic( $topic, $web, $res["full_text"], $res["summary"] );
			return true;
			}
		}

	return false;
	} /* end checkRendering */

function PrintWikiTopic($topic, $web, $expected = true)
{
if( $result = FetchWikiEntry($topic, $web, $expected) ) {
	/* only one row because topic is a primary key, and thus, unique. */
	$row = mysql_fetch_array($result);

	if ( checkRendering( $topic, $web, $expected ) ) {
		PrintWikiTopic($topic, $web, $expected);
		return;
		}
	print( stripslashes($row["rendertext"]) );
	} /* end if query succeeded */
} /* end PrintWikiTopic() */

function PrintWikiBodyText($topic, $web, $expected = true)
{
if( $result = FetchWikiEntry($topic, $web, $expected) ) {
	/* only one row because topic is a primary key, and thus, unique. */
	$row = mysql_fetch_array($result);
	$text = stripslashes($row["full_text"]);

	/* escape entities */
	$text = preg_replace( "/&([^;]*);/", "&amp;\\1;", $text );
	print $text;
	} /* end if query succeeded */
} /* end PrintWikiBodyText() */

function PrintWikiSummary($topic, $web, $expected = false)
{
if( ($result = FetchWikiEntry($topic, $web, false)) ) {
	$row = mysql_fetch_array($result);
	print( stripslashes($row["summary"]) );
	} 
} /* end printWikiSummary() */

function FetchWikiEntry($topic, $web, $expected)
{
global $_SITE;

/* connect to the MySQL database */
$db = getDatabase();

/* does the web in question exist? */
if( ! webExists($web, $db) ) {
	if ( $expected ) {
	        $editlink = $_SITE["docrootdir"] . "edit.php3?web=" . $web . "&topic=" . $topic;
		include( $_SITE["mirrordir"] . "no_web.ihtml" );
		}
	return false;	
	}

$websl = addslashes($web);
$topicsl = addslashes($topic);

$query = "SELECT * FROM " . $_SITE["dbtable"] . " WHERE topic=\"$topicsl\"&&web=\"$websl\";";

/* perform a query */
if ( ! ($result = mysql_query( $query, $db ) ) ) {
	if ( $expected ) {
		$error_body = mysql_error($db) . " (" . mysql_errno($db) . ")";
		include( $_SITE["mirrordir"] . "query_failed.ihtml" );
		}
	mysql_close( $db );
	return false;
	}	  

/* process the result */
if ( mysql_num_rows($result) == 0 ) {
	if ( $expected ) {
	        $editlink = $_SITE["docrootdir"] . "edit.php3?web=" . $web . "&topic=" . $topic;
       		include($_SITE["mirrordir"] . "no_topic.ihtml");
		}
        return false;
	}
else {
	/* the topic body */
	return $result;
	}

mysql_free_result( $result );
mysql_close( $db );
return true;
} /* end fetchWikiEntry() */
?>
